<template>
  <v-container grid-list-xl>
    <v-layout   wrap justify-space-around>
<!---  <v-card class="mx-auto" max-width="100%">--->
    <v-card class="mx-auto mb-5" outlined width="100%">
      <confirmation-modal :is-open="openModal" :modal-text="modal.text" @confirm="confirmUnlockBlock" @cancel="cancelRegister" :textButton="modal.textButton" :colorIcon="modal.iconColor"/>
      <v-card-subtitle class="pb-0">
        <image-field v-model="specialist.user.image" :disabled="disabled_user_info" :validation="imageValidation"  :url-image="specialist.profileImage"/>
        <v-divider></v-divider>
        <v-form ref="form" lazy-validation>
          <v-container fluid>
            <select-field  v-model="specialist.user.typeDocument" :disabled="disabled_user_info" :items="typesDocument" fieldName="Tipo de documento" ></select-field>
            <register-field-validation
              v-if="specialist.user.typeDocument==='DNI'"
              v-model="specialist.user.document"
              field-name="DNI"
              :validation="DNIValidation"
              place-holder="Ingrese DNI"
              :disabled="disabled_user_info"
            />
            <register-field-validation
              v-if="specialist.user.typeDocument==='CARNET EXTRANJERÍA'"
              v-model="specialist.user.document"
              field-name="Carnet de extranjería"
              :validation="carnetValidation"
              place-holder="Ingrese Carnet de extranjería"
              :disabled="disabled_user_info"
            />
            <register-field-validation
              v-if="specialist.user.typeDocument==='PASAPORTE'"
              v-model="specialist.user.document"
              field-name="Pasaporte"
              :validation="passportValidation"
              place-holder="Ingrese Pasaporte"
              :disabled="disabled_user_info"
            />
            <register-field-validation v-model="specialist.user.name" :disabled="disabled_user_info" field-name="Nombre" :validation="nameValidation" place-holder="Ingrese nombre"  />
            <register-field-validation v-model="specialist.user.fatherLastname" :disabled="disabled_user_info" field-name="Apellido paterno" :validation="fatherLastnameValidation" place-holder="Ingrese apellido paterno" />
            <register-field-validation v-model="specialist.user.motherLastname" :disabled="disabled_user_info" field-name="Apellido materno " :validation="motherLastNameValidation" place-holder="Ingrese apellido materno" />
            <email-field v-model="specialist.email" :disabled="disabled_user_info" field-name="Correo" :validation="emailValidation"/>
            <register-field-validation v-model="specialist.phoneNumber" :disabled="disabled_user_info" field-name="Celular" :validation="phoneValidation" place-holder="Ingrese número celular"  :obligatory="false"/>
            <directions-field v-model="specialist.address" field-name="Domicilio" :disabled="disabled_user_info"  place-holder="Ingrese domicilio" :obligatory="false"/>
            <picker-field v-model="specialist.user.birthdate" :disabled="disabled_user_info" field-name="Fecha de Nacimiento" />
            <register-field-validation v-model="specialist.specialty" field-name="Especialidad" :disabled="disabled_user_info" place-holder="Ingrese especialidad"/>
          </v-container>
        </v-form>
      </v-card-subtitle>
      <v-card-actions class="d-flex justify-end">
        <v-btn depressed color="primary" style="padding: 15px" rounded outlined @click="editar">EDITAR</v-btn>
      </v-card-actions>
      <br>
      <v-snackbar v-model="snackBar.show" :color="snackBar.color" text top>
        {{ snackBar.text }}
        <template v-slot:action="{ attrs }">
          <v-btn color="blue" text v-bind="attrs" @click="snackBar.show = false">
            <v-icon>mdi-window-close</v-icon>
          </v-btn>
      </template>
      </v-snackbar>
    </v-card>
    <block-user
      v-if="!specialist.isBlocked"
      :titleText="blockInformation.title"
      :subtitleText1="blockInformation.subtitle1"
      :user="specialist"
      :subtitleText2="blockInformation.subtitle2"
      @clickPrincipalButton="unlockBlockUser"
      :confirmText="blockInformation.confirm"
      :color="blockInformation.color"
      :textButton="blockInformation.textButton"
      />
    <block-user
      v-if="specialist.isBlocked"
      :titleText="unlockInformation.title"
      :subtitleText1="unlockInformation.subtitle1"
      :user="specialist"
      :subtitleText2="unlockInformation.subtitle2"
      @clickPrincipalButton="unlockBlockUser"
      :confirmText="unlockInformation.confirm"
      :color="unlockInformation.color"
      :textButton="unlockInformation.textButton"
    />
    </v-layout>
  </v-container>

</template>

<script>
import { mapActions, mapState, mapGetters } from "vuex";
import RegisterFieldValidation from "~/components/InputField/RegisterFieldValidation";
import PickerField from "~/components/InputField/PickerField";
import SelectField from "~/components/InputField/SelectField.vue"
import ButtonsRegisterForm from "~/components/InputField/ButtonsRegisterForm.vue";
import imageField from "~/components/InputField/ImageField";
import ConfirmationModal from '~/components/register/confirmationModal';
import BlockUser from '~/components/BlockUser';
import {
  DNIRules,
  nameRules,
  fatherLastnameRules,
  motherLastnameRules,
  emailRules,
  imageFileRules,
  phoneRules, carnetRules, passportRules,
} from "@/helpers/validation";

import DirectionsField from '~/components/InputField/DirectionsField';
import EmailField from '~/components/InputField/EmailField'

export default {
    name: 'ShowSpecialist',
    components: { RegisterFieldValidation, PickerField, ButtonsRegisterForm,imageField, ConfirmationModal, SelectField, DirectionsField, EmailField, BlockUser},
    data: () => ({
      typeDocumentSelected: 'DNI',
      typesDocument: [ 'CARNET EXTRANJERÍA','DNI', 'PASAPORTE'],
      disabled_user_info: true,
      disabled_specialist_info: true,
      DNIValidation: DNIRules,
      carnetValidation: carnetRules,
      passportValidation: passportRules,
      nameValidation: nameRules,
      fatherLastnameValidation: fatherLastnameRules,
      motherLastNameValidation: motherLastnameRules,
      emailValidation: emailRules,
      imageValidation: imageFileRules,
      phoneValidation: phoneRules,
      openModal: false,
      modal:{
        text: '',
        iconColor:'',
        textButton:'',
      },
      snackBar:{
        show:false,
        color:'',
        text:'',
      },
      specialist:{
          user:{
              image: null,
          }
      },
      unlockInformation:{
          title:'Desbloquear al especialista',
          subtitle1:'La acción habilitará al especialista ',
          subtitle2:'inmediatamente, otorgándole la posibilidad de acceder al sistema como usuario especialista y permitiendo el desarrollo de sus actividades.',
          confirm:'¿Esta seguro que desea desbloquear al especialista?',
          color:'primary',
          textButton:'Desbloquear',
      },
      blockInformation:{
          title:'Bloquear al especialista',
          subtitle1:'La acción deshabilitará al especialista ',
          subtitle2: 'inmediatamente, restringiendo el acceso al sistema como usuario especialista y también en el desarrollo de sus actividades.',
          confirm:'¿Esta seguro que desea bloquear al especialista?',
          color:'error',
          textButton:'Bloquear'
      }
    }),

    computed:{
      ...mapState({
        checkedSpecialist: state => state.specialists.checkedSpecialist,
      }),
      ...mapGetters({
        storedSpecialist: 'specialists/getOneSpecialist',
      }),
    },
    async mounted() {
        this.clearForm();
        await this.getASpecialist();
    },
    methods:{
      ...mapActions({
        getSpecialists: 'specialists/getSpecialists',
        getSpecialist: 'specialists/getSpecialist',
        checkedInformationSpecialist: 'specialists/checkedInformationSpecialist',
        unlockSpecialist: 'specialists/unlockSpecialist',
        blockSpecialist: 'specialists/blockSpecialist'
      }),
      unlockBlockUser(){
        if (this.specialist.isBlocked) {
            this.modal.text = this.unlockInformation.confirm;
            this.modal.iconColor = this.unlockInformation.color;
            this.modal.textButton = "Desbloquear";
        }
        if (!this.specialist.isBlocked) {
            this.modal.text = this.blockInformation.confirm;
            this.modal.iconColor = this.blockInformation.color;
            this.modal.textButton = "Bloquear";
        }
        this.openModal = true;
      },
      async confirmUnlockBlock() {
        if (this.specialist.isBlocked) await this.unlockSpecialist(this.specialist.uuid);
        if (!this.specialist.isBlocked) await this.blockSpecialist(this.specialist.uuid);
        await this.$router.push('/especialistas');
      },

      async getASpecialist() {
        await this.getSpecialist({ uuid: this.$route.params.id });
        this.specialist = Object.assign({}, this.storedSpecialist);
        console.log(this.storedSpecialist);
        console.log(this.specialist);
        if (this.specialist.user.typeDocument === 'CARNET') {
          this.specialist.user.typeDocument = 'CARNET EXTRANJERÍA';
        }
      },
      cancelRegister() {
        this.openModal = false;
      },

      cancelForm(){
        //this.$refs.form.reset();
        this.$router.push('/especialistas');
      },
      editar(){
        this.$router.push(`/especialistas/editar-especialista/${this.specialist.uuid}`);
      },
      setNackBar(text, color, show){
        this.snackBar.text = text;
        this.snackBar.show = show;
        this.snackBar.color = color;
      },
      clearForm(){
        this.specialist.user.name='';
        this.specialist.user.fatherLastname='';
        this.specialist.user.motherLastname='';
        /*this.specialist.user.email= '';
        this.specialist.user.phoneNumber= '';
        this.specialist.user.address= '';
        this.specialist.user.birthdate='';
        this.specialist.specialty='';*/
      }
    }
}
</script>
